
#include <stdio.h>
#include <stdlib.h>
#include <sys/name.h>
#include <sys/dev.h>
#include <sys/fd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/psinfo.h>
#include <sys/stat.h>
#include <errno.h>

main(int argc, char **argv)
{
pid_t scr;
int fd;
struct _fd_entry buf;
struct _dev_info_entry info;
int keepgo = 1;
int fdi;

scr = qnx_name_locate(0,"qnx/screen",10,NULL);
if ( scr == -1 ) perror("name locate");

for ( fd=0; keepgo && ((fd = qnx_fd_query( 0, scr, fd, &buf )) != -1); ++fd ) {
    if ( dev_fdinfo( buf.pid, scr, fd, &info ) == 0  ) {
       printf("fd=%d type=%s name=%s flag=%x\n",fd, info.driver_type, &info.tty_name[0], buf.flags);
       if ( strcmp(info.driver_type, "console") == 0 && (buf.flags & _FD_CLOSE_ON_EXEC) )
          keepgo = 0;
       }
    }

/* now we've got one */
if ( keepgo == 0 ) {
   printf("opening %s\n",&info.tty_name[0]);
   fdi = open(&info.tty_name[0], O_RDWR);
   printf("fdi=%d\n",fdi);
sleep(10);
   insertit(fdi, "abcdef");
   insertit(fdi, "\n\n");
   }
}

insertit(int fd, char *str)
{
int ret;

ret = dev_insert_chars(fd,strlen(str),str);
if ( ret == -1 )
   printf("ret=%d, err=%s\n",ret, strerror(errno));
}

