/* keyboard_api.c */

#include <stdio.h>
#include <stdlib.h>
#include <sys/name.h>
#include <process.h>
#include <windows/Qwindows.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>

#include "keyinject.h"

int display_keyboard(int row, int col, int wid, int command)
{
/** local data **/
	/* event message sent to Graphical Keyboard task */
	QW_EVENT_HDR	cmd_event;

   /* return value from library functions */
   int   status = 0;

   /* Graphical Keyboard task id */
   static pid_t  tid_keyboard;

   /* char buffer for holding the converted passed ints to chars */
   char  buffer[10];
   char buf1[10], buf2[10], buf3[10], buf4[10];

/** code **/

   /* check if keyboard task exists */
   tid_keyboard = qnx_name_locate(0,KEYBOARD, 10, NULL);

   if (-1 == tid_keyboard)
   {
      /* task doesn't exist */
      status = -1;
   }

   /* check user passed in command for removing task */

   /* if command is to terminate keyboard (REMOVE it) */
  	/* set up admin message */
   if ((GK_CLOSE == command) && (-1 != tid_keyboard))
   {
     	cmd_event.id = QW_EVENT;
     	cmd_event.size = sizeof(QW_EVENT_HDR);
     	cmd_event.key[0] = '\0';
     	cmd_event.code = 0;

     	/* request the task to die*/
     	cmd_event.action = GK_CLOSE;

     	/* send it! */
     	status = PutEvent((char *) NULL, tid_keyboard, &cmd_event);

      if (status != tid_keyboard)
      {
         /* couldn't send to Graphical Keyboard Task */
         status = -2;
      }
   }
   else if (GK_OPEN == command)
   {

      /* verify that the keyboard task is there */
      if (-1 == tid_keyboard)
      {
         /* start the keyboard task */
         strcpy(buf1, itoa(row, buffer,10));
         strcpy(buf2, itoa(col, buffer,10));
         strcpy(buf3, itoa(wid, buffer,10));
         strcpy(buf4, itoa(getpid(), buffer,10));
         tid_keyboard = spawnl( P_NOWAITO,
                                "GraphKey", 
                                "GraphKey",
                                buf1,
                                buf2,
                                buf3,
                                buf4,
                                NULL);
         if (-1 == tid_keyboard)
         {
            /* could not create the Graphical Keyboard Task */
            status = -1;
         }
         else
         {
            /* created successfully */
            status = 0;
         }
      }

      if (0 == status)
      {
         /* application informing Graphical Keyboard of the window that */
         /* will be receiving the keystrokes from the Window Server */
         cmd_event.id = QW_EVENT;
         cmd_event.size = sizeof(QW_EVENT_HDR);
         cmd_event.code = 0;

         /* request the task to locate the window */
         cmd_event.action = GK_OPEN; 

         /* pass the row position */
         strcpy(cmd_event.key, itoa(row, buffer, 10));

         /* seperate it with a space */
         strcat(cmd_event.key, " ");

         /* pass the column position */
         strcat(cmd_event.key, itoa(col, buffer, 10));

         /* seperate it with a space */
         strcat(cmd_event.key, " ");

         /* get the window id into the key element */
         strcat(cmd_event.key, itoa(wid, buffer, 10));

         strcat(cmd_event.key, " ");
         strcat(cmd_event.key, itoa(getpid(), buffer, 10));

         /* send it! */
         status = PutEvent(NULL, tid_keyboard, &cmd_event);

         if (status != tid_keyboard)
         {
            /* couldn't send to Graphical Keyboard Task */
            status = -2;
         }
      }
   }
   return(status);
}
