/* used for row or col parameters if Application does not want */
/* to change the position of the row or col for the Graphical  */
/* Keyboard.                                                   */
#define  GK_KEEP  -1

/* string for Graphical Keyboard name that is attached to the */
/* QNX Name Server.                                           */
#define  KEYBOARD "GraphKey"

#define KS_WINDOW_MGR  -1

/* Legal commands for the Graphical Keyboard Task */
enum cmd_events
{
   GK_NO_COMMAND = 0,   /* No command */
   GK_OPEN,             /* Display the Graphical Keyboard */
   GK_CLOSE             /* Remove the Graphical Keyboard */
};



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 
 * FUNCTION NAME:       Graphical Keyboard API
 * 
 * DESCRIPTION:         The Graphical Keyboard shall replace the 
 *                      functionality of a physical keyboard.Due
 *                      to the difference in the user interface
 *                      between a physical keyboard and a 
 *                      graphical keyboard,the key layout for the
 *                      graphical keyboard will be alphabetical.  
 *                    
 * 
 * INPUT PARAMETERS:    row - upper left corner row postion for the
 *                            Graphical Keyboard.
 *                      col - upper left corner column position for
 *                            the Graphical Keyboard.
 *                      wid - The window id of the window which will
 *                            be receiving the keystrokes.
 *                      command - GK_OPEN = start Graphical Keyboard
 *                                          Task and inform it of 
 *                                          the window id and task 
 *                                          id receiving keystrokes.
 *                                GK_CLOSE = remove the Graphical 
 *                                           Keyboard from the screen
 *
 * 
 * RETURN VALUE:        0 = Success
 *                     -1 = Couldn't create task
 *                     -2 = Couldn't talk to task
 *                      
 * CALLED BY:           Application
 * 
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int display_keyboard(int row, int col, int wid, int command);
